%define bind_version 9.18.8
%global openssl_pkcs11_version 0.4.12-1
%global softhsm_version 2.6.1-1

Summary:        LDAP back-end plug-in for BIND
Name:           bind-dyndb-ldap
Version:        11.10
Release:        10%{?dist}
License:        GPLv2+
URL:            https://releases.pagure.org/bind-dyndb-ldap
Source0:        https://releases.pagure.org/%{name}/%{name}-%{version}.tar.bz2
Source1:        https://releases.pagure.org/%{name}/%{name}-%{version}.tar.bz2.asc

BuildRequires:  bind-devel >= %{bind_version}, bind-lite-devel >= %{bind_version}
BuildRequires:  krb5-devel openldap-devel libuuid-devel
BuildRequires:  automake, autoconf, libtool autoconf-archive
Requires:       softhsm >= %{softhsm_version}
Requires:       openssl-pkcs11 >= %{openssl_pkcs11_version}
Requires(pre):  bind >= %{bind_version}
Requires:       bind >= %{bind_version}

Patch0001:      0001-adopt-to-bind-9.18.9-loggers.patch
Patch0002:      0002-Support-bind-9.18.10-or-later.patch
Patch0003:      0003-Handle-dns_db_allrdatasets-backports-too.patch
Patch0004:      0004-use-BIND-macros-when-defining-DNS-names.patch
Patch0005:      0005-detect-and-propagate-atomic-libraries.patch
Patch0006:      0006-fix-setmaxrrperset-missing-initializer.patch
Patch3000:      bind-dyndb-ldap-11.10-bind-9.18.11.patch
Patch3001:      bind-dyndb-ldap-11.10-bind-9.18.13.patch

%description
This package provides an LDAP back-end plug-in for BIND. It features
support for dynamic updates and internal caching, to lift the load
off of your LDAP server.

%prep
%autosetup -n %{name}-%{version} -p1

%build
autoreconf -fiv
export BIND9_CFLAGS='-I /usr/include/bind9 -DHAVE_TLS -DHAVE_THREAD_LOCAL'
%configure
%make_build

%install
%make_install
mkdir -m 770 -p %{buildroot}/%{_localstatedir}/named/dyndb-ldap

rm %{buildroot}%{_libdir}/bind/ldap.la
rm -r %{buildroot}%{_datadir}/doc/%{name}

%post
[ -f /etc/named.conf ] || exit 0

PLATFORM=$(uname -m)

if [ $PLATFORM == "x86_64" ] ; then
    LIBPATH=/usr/lib64
else
    LIBPATH=/usr/lib
fi

while read -r PATTERN
do
    SEDSCRIPT+="$PATTERN"
done <<EOF
/^\s*dynamic-db/,/};/ {

  s/\(\s*\)arg\s\+\(["']\)\([a-zA-Z_]\+\s\)/\1\3\2/g;

  s/^dynamic-db/dyndb/;

  s@\(dyndb "[^"]\+"\)@\1 "$LIBPATH/bind/ldap.so"@;
  s@\(dyndb '[^']\+'\)@\1 '$LIBPATH/bind/ldap.so'@;

  /\s*library[^;]\+;/d;
  /\s*cache_ttl[^;]\+;/d;
  /\s*psearch[^;]\+;/d;
  /\s*serial_autoincrement[^;]\+;/d;
  /\s*zone_refresh[^;]\+;/d;
}
EOF

sed -i.bak -e "$SEDSCRIPT" /etc/named.conf

%files
%license COPYING
%doc NEWS README.md doc/{example,schema}.ldif
%dir %attr(770, root, named) %{_localstatedir}/named/dyndb-ldap
%{_libdir}/bind/ldap.so

%changelog
* Mon Sep 02 2024 Xin Cheng <denisecheng@tencent.com> - 11.10-10
- [Type] bugfix
- [DESC] fix error "isc/stdatomic.h does not support your compiler"

* Wed Aug 28 2024 Rebuild Robot <rebot@opencloudos.org> - 11.10-9
- [Type] security
- [DESC] Rebuilt for bind

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11.10-8
- Rebuilt for loongarch release

* Thu Feb 29 2024 denisecheng@tencent.com - 11.10-7
- add 0004-use-BIND-macros-when-defining-DNS-names.patch

* Mon Nov 13 2023 cunshunxia@tencent.com - 11.10-6
- Rebuilt for bind 9.18.19

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11.10-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 kianli <kianli@tencent.com> - 11.10-4
- Rebuilt for bind 9.18.18

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11.10-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 11.10-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Nov 29 2022 Xin Cheng <denisecheng@tencent.com> - 11.10-1
- package init.
